<template>
  <teleport to="body">
    <transition name="ui-modal">
      <div
        v-if="isOpen"
        class="ui-modal uikit-fixed uikit-z-modal uikit-inset-0 uikit-flex uikit-overflow-auto uikit-px-ui-page-spacing"
        tabindex="-1"
        role="dialog"
      >
        <div class="ui-modal-backdrop"></div>

        <div
          class="ui-modal-box"
          :style="styleList"
          ref="root"
          tabindex="1"
        >
          <div
            v-if="label"
            class="label"
          >
            {{ label }}
          </div>
          <button
            @click="handleClose"
            :disabled="!closable"
            class="uikit-group uikit-absolute 375:top-32 uikit-top-24 375:right-24 uikit-right-16 uikit-h-36 uikit-w-36 uikit-p-0 m-0 uikit-border-opacity-20 active:border-opacity-100 uikit-border uikit-border-white uikit-rounded-full uikit-flex uikit-justify-center uikit-items-center hover:border-opacity-30 uikit-transition-colors uikit-duration-150 disabled:text-white disabled:uikit-text-opacity-30 disabled:hover:uikit-border-opacity-50"
          >
            <ui-icon-close
              class="uikit-text-gray-600 group-hover:uikit-text-white group-active:uikit-text-white uikit-w-10"
            />
          </button>
          <div class="uikit-relative uikit-overflow-hidden 375:uikit-pt-32 uikit-pt-24 375:uikit-px-24 uikit-px-16">
            <slot />
          </div>
        </div>
      </div>
    </transition>
  </teleport>
</template>

<script lang="ts">
  import { defineComponent, watch, computed, onBeforeUnmount } from 'vue'
  import { useVModel, useEventListener } from '@vueuse/core'
  import { useUiBodyScrollLock } from '../../composable'
  import { UiIconClose } from '../UiIcon'
  import { isBrowser } from '../../utils/isBrowser'
  import { getDocument } from '../../utils/getElement'

  export default defineComponent({
    name: 'ui-modal',
    props: {
      modelValue: {
        type: Boolean,
        default: false,
      },
      maxWidth: {
        type: String,
        default: '450px',
      },
      label: {
        type: String,
        default: '',
      },
      closable: {
        type: Boolean,
        default: true,
      },
    },
    setup(props, { emit }) {
      let prevActiveElement = null as null | HTMLElement
      const isOpen = useVModel(props, 'modelValue', emit)
      const { toggleLock } = useUiBodyScrollLock()
      const styleList = computed(() => ({ maxWidth: props.maxWidth }))
      const handleClose = () => {
        if (props.closable) {
          isOpen.value = false
        }
      }

      if (isBrowser) {
        useEventListener(getDocument(), 'keyup', ({ key }: KeyboardEvent) => {
          key === 'Escape' && handleClose()
        })
      }
      watch(isOpen, (isOpenVal) => {
        toggleLock(isOpenVal)
        const document = getDocument()

        if (isOpenVal && document && document.activeElement && (document.activeElement as HTMLElement).blur) {
          prevActiveElement = document.activeElement as HTMLElement
          ;(document.activeElement as HTMLElement).blur()
        } else {
          if (prevActiveElement && document && document.body.contains(prevActiveElement)) {
            prevActiveElement.focus()
          }
          prevActiveElement = null
        }
      })

      onBeforeUnmount(() => {
        toggleLock(false)
      })

      return { isOpen, handleClose, styleList }
    },
    components: { UiIconClose },
  })
</script>

<style>
  .ui-modal-backdrop {
    z-index: 0;
    @apply uikit-bg-black uikit-bg-opacity-70 uikit-backdrop-blur-8 uikit-fixed uikit-inset-0;
  }

  .ui-modal-box {
    @apply uikit-overflow-hidden uikit-m-auto uikit-flex-grow-0 uikit-w-full uikit-relative uikit-z-10 uikit-bg-black 375:uikit-py-32 uikit-py-24 uikit-border uikit-border-white uikit-text-white uikit-rounded-20
  }

  .ui-modal-box > .label {
    @apply 375:uikit-pl-24 uikit-pl-16 uikit-font-title uikit-text-ui-page-label uikit-leading-140 uikit-pr-64 uikit-h-36 uikit-box-content uikit-flex uikit-items-center uikit-justify-start
  } 

  .ui-modal-enter-active,
  .ui-modal-leave-active {
    transition: all 0.6s;
  }

  .ui-modal-enter-from,
  .ui-modal-leave-to {
    opacity: 1;
  }

  .ui-modal-enter-active > .ui-modal-backdrop {
    transition: all 0.3s uikit-ease-out;
  }

  .ui-modal-leave-active > .ui-modal-backdrop {
    transition: all 0.3s 0.3s uikit-ease-out;
  }

  .ui-modal-enter-from > .ui-modal-backdrop,
  .ui-modal-leave-to > .ui-modal-backdrop {
    opacity: 0;
  }

  .ui-modal-enter-active > .ui-modal-box {
    transition: all 0.3s 0.3s uikit-ease-out;
  }

  .ui-modal-leave-active > .ui-modal-box {
    transition: all 0.3s uikit-ease-out;
  }

  .ui-modal-enter-from > .ui-modal-box,
  .ui-modal-leave-to > .ui-modal-box {
    opacity: 0;
  }
</style>
